/**
 * @Filename Defines.hpp
 * @Description Some basic definitions used in the code.
 * @Status Scheduled for termination.
 * @Version $Id: Defines.hpp 5913 2013-02-10 12:15:21Z jreis $
 * @Maintainer Nelson Ramos (nmsra@mega.ist.utl.pt)
 */

#ifndef __SOCROB_DEFINES_HPP__
#define __SOCROB_DEFINES_HPP__

#include <utility>



typedef float Distance; ///< Holds distances (in meters)
typedef float Angle; ///< Holds angles
typedef Angle Angle_Deg; ///< Holds angles in degrees
typedef float Speed; ///< Holds speed values
typedef float Rotation_Speed; ///< Holds angular speed values



typedef std::pair<float, float> point;
typedef std::pair<point, point> line;



enum CONTROL_TYPE {
  VELOCITY,
  ACCELERATION
};
enum CONTROL_PRIORITY {
  BALANCED,
  LINEAR,
  ANGULAR
};
#endif
