/**
 * @Filename Exception.hpp
 * @Description ReturnValue declaration
 * @Status Work in Progress
 * @Version $Id: Exception.hpp 5913 2013-02-10 12:15:21Z jreis $
 * @Maintainer nmsra (nmsra@mega.ist.utl.pt)
 */

#ifndef __ERRORRHANDLING_EXCEPTION_H_
#define __ERRORRHANDLING_EXCEPTION_H_

#include <string>
#include <stdexcept>



namespace mermaid
{
  namespace support
  {
    namespace errorhandling
    {
      /**
      * @Class Exception Exception.hpp "Exception.hpp"
      * @Description Exception base class the represents all exceptions thrown by MeRMaID
      * @Author Marco Barbosa + Nelson Ramos
      */
      class Exception : public std::runtime_error
      {
        public:
          /**
           * @Description Constructor.
           * @Param description Description of the failure that raised this exception.
           * @Author Marco Barbosa + Nelson Ramos
           */
          Exception (const std::string& description);
      };
    } // namespace errorhandling
  } // namespace support
} // namespace mermaid

#endif
