/**
 * @Filename FilePathSearch.hpp
 * @Description FilePathSearch declaration
 * @Status Work in Progress
 * @Version $Id: FilePathSearch.hpp 5913 2013-02-10 12:15:21Z jreis $
 * @Maintainer Marco Barbosa
 */

#ifndef __SYSTEM_FILEPATHSEARCH_H
#define __SYSTEM_FILEPATHSEARCH_H

#include <list>
#include <string>



namespace mermaid
{
  namespace support
  {
    namespace system
    {
      /**
       * @Class FilePathSearch FilePathSearch.hpp "FilePathSearch.hpp"
       * @Description A class providing search for files in known paths
       * @Author Marco Barbosa
       */
      class FilePathSearch
      {
        public:
          static void addSearchPath (std::string path);
          static std::string getFullPathForFile (std::string filename);
          
        private:
          static std::list<std::string> pathList_;
      }; // class FilePathSearch
    } // namespace system
  } // namespace support
} // namespace mermaid

#endif
