/**
 * @Filename XmlConvertible.hpp
 * @Description XmlConvertible declaration file.
 * @Status Implementing
 * @Version $Id: XmlConvertible.hpp 5913 2013-02-10 12:15:21Z jreis $
 * @Maintainer Nelson Ramos (nmsra@mega.ist.utl.pt)
 */

#ifndef __XML_XMLCONVERTIBLE_H_
#define __XML_XMLCONVERTIBLE_H_



namespace mermaid
{
  namespace support
  {
    namespace xml
    {
      class XmlConvertible;
    }
  }
}

#include "XmlElement.hpp"



namespace mermaid
{
  namespace support
  {
    namespace xml
    {
      /**
      * @Class XmlConvertible XmlConvertible.h "XmlConvertible.h"
      * @Description Class that is to be inherited by classes that are able
      * to produce XML output
      * @Author Marco Barbosa
      */
      class XmlConvertible
      {
        public:
          virtual ~XmlConvertible();
          
          /**
          * @Description Operator that converts to an XmlElement
          * @Author Marco Barbosa
          */
          virtual operator XmlElement() = 0;
      }; // class XmlConvertible
    } // namespace xml
  } // namespace support
} // namespace mermaid

#endif
