/**
 * @Filename XmlEntityLoader.hpp
 * @Description Class used to load external entities
 * @Status Implementing
 * @Version $Id: XmlEntityLoader.hpp 5913 2013-02-10 12:15:21Z jreis $
 * @Maintainer Marco Barbosa
 */

#ifndef __XML_XMLENTITYLOADER_H
#define __XML_XMLENTITYLOADER_H



namespace mermaid
{
  namespace support
  {
    namespace xml
    {
      class XmlEntityLoader;
    }
  }
}



typedef struct _xmlParserInput xmlParserInput;
typedef xmlParserInput* xmlParserInputPtr;
typedef struct _xmlParserCtxt xmlParserCtxt;
typedef xmlParserCtxt* xmlParserCtxtPtr;
typedef xmlParserInputPtr (*xmlExternalEntityLoader) (const char* URL,
    const char* ID,
    xmlParserCtxtPtr context);



namespace mermaid
{
  namespace support
  {
    namespace xml
    {
      /**
       * @Class XmlEntityLoader XmlEntityLoader.h "XmlExternalEntityLoader.h"
       * @Description Class that holds the entity loader function
       * @Author Marco Barbosa
       */
      class XmlEntityLoader
      {
        public:
          static xmlParserInputPtr loaderFunction (const char* URL,
              const char* ID,
              xmlParserCtxtPtr context);
              
        private:
          static xmlExternalEntityLoader defaultLoader_;
      }; // XmlEntityLoader
    } // namespace xml
  } // namespace support
} // namespace mermaid

#endif
