/**
 * @Filename FilePathSearch.cpp
 * @Description FilePathSearch implementation
 * @Status Work in Progress
 * @Version $Id: FilePathSearch.cpp 5913 2013-02-10 12:15:21Z jreis $
 * @Maintainer Marco Barbosa
 */

#include "FilePathSearch.hpp"

#include <fstream>
#include <iostream>

#include <Exception.hpp>



using namespace mermaid::support::system;
using mermaid::support::errorhandling::Exception;



std::list<std::string> FilePathSearch::pathList_ = std::list<std::string>();



void FilePathSearch::addSearchPath (std::string path)
{
  //std::cerr << "FilePathSearch::addSearchPath : path=" << path << std::endl;
  pathList_.push_back (path);
};



std::string FilePathSearch::getFullPathForFile (std::string filename)
{
  std::list<std::string>::iterator pathIt;
  
  for (pathIt = pathList_.begin(); pathIt != pathList_.end(); pathIt++) {
    std::string path = *pathIt;
    
    //std::cerr << "FilePathSearch::getFullPathForFile : trying path: \"" << path << "\"" << std::endl;
    
    std::string fullPath = path + "/" + filename;
    
    //std::cerr << "FilePathSearch::getFullPathForFile : full path: \"" << fullPath << "\"" << std::endl;
    
    std::ifstream stream;
    
    stream.open (fullPath.c_str());
    
    if (stream.is_open()) {
      //std::cerr << "FilePathSearch::getFullPathForFile : found path: \"" << fullPath << "\"" << std::endl;
      stream.close();
      return fullPath;
    }
    else {
      //std::cerr << "FilePathSearch::getFullPathForFile : invalid path: \"" << fullPath << "\"" << std::endl;
    }
  }
  
  throw Exception ("FilePathSearch::getFullPathForFile : path not found for filename: " + filename);
};
