/**
 * @Filename XmlAttribute.cpp
 * @Description Implementation of the XmlAttribute class
 * @Status Finished
 * @Version $Id: XmlAttribute.cpp 5913 2013-02-10 12:15:21Z jreis $
 * @Maintainer Nelson Ramos (nmsra@mega.ist.utl.pt)
 */

#include "XmlAttribute.hpp"

#include <string>

#include <libxml/xmlmemory.h>
#include <libxml/parser.h>



using namespace mermaid::support::xml;



XmlAttribute::XmlAttribute (xmlAttrPtr attr) :
  name_ ( (char*) attr->name),
  value_ ( (char*) attr->children->content)
{
}



const string XmlAttribute::getName() const
{
  return name_;
}



const string XmlAttribute::getValue() const
{
  return value_;
}
