/**
 * @Filename XmlAttributeVector.cpp
 * @Description Implementation of the XmlAttributeVector class
 * @Status Implementing
 * @Version $Id: XmlAttributeVector.cpp 5913 2013-02-10 12:15:21Z jreis $
 * @Maintainer
 */

#include "XmlAttributeVector.hpp"

#include <string>

#include "XmlAttribute.hpp"



using namespace mermaid::support::xml;
using std::string;



XmlAttributeVector XmlAttributeVector::getAttributesWithName (string name)
{
  XmlAttributeVector vector;
  
  for (XmlAttributeVector::iterator it = begin();
       it != end();
       it++) {
    shared_ptr<XmlAttribute> e = *it;
    string s = e->getName();
    
    if (s.compare (name) == 0) {
      vector.push_back (e);
    }
  }
  
  return vector;
}



shared_ptr<XmlAttribute> XmlAttributeVector::getFirstAttributeWithName (string name)
{
  XmlAttributeVector v = getAttributesWithName (name);
  
  if (v.size() > 0) {
    return v[0];
  }
  else {
    return shared_ptr<XmlAttribute>();
  }
}
