/**
 * @Filename XmlElementVector.cpp
 * @Description Implementation of the XmlElementVector class
 * @Status Implementing
 * @Version $Id: XmlElementVector.cpp 5913 2013-02-10 12:15:21Z jreis $
 * @Maintainer Nelson Ramos (nmsra@mega.ist.utl.pt)
 */

#include "XmlElementVector.hpp"

#include <string>

#include "XmlElement.hpp"



using namespace mermaid::support::xml;
using std::string;



XmlElementVector XmlElementVector::getElementsWithName (string name)
{
  XmlElementVector vector;
  
  for (XmlElementVector::iterator it = begin();
       it != end();
       it++) {
    shared_ptr<XmlElement> e = *it;
    string s = e->getName();
    
    if (s.compare (name) == 0) {
      vector.push_back (e);
    }
  }
  
  return vector;
}



shared_ptr<XmlElement> XmlElementVector::getFirstElementWithName (string name)
{
  XmlElementVector v = getElementsWithName (name);
  
  if (v.size() > 0) {
    return v[0];
  }
  else {
    return shared_ptr<XmlElement>();
  }
}
