#include <boost/thread.hpp>

#include <nodelet/nodelet.h>

#include <pluginlib/class_list_macros.h>

#include "mjpeg_camera.h"



using namespace std;
using namespace ros;



class MjpegCameraNodelet:
  public nodelet::Nodelet
{
  public:
    MjpegCameraNodelet() :
      running_ (false)
    {}
    
    ~MjpegCameraNodelet() {
      if (running_) {
        NODELET_INFO ("shutting down driver thread");
        running_ = false;
        thread_.join();
        NODELET_INFO ("driver thread stopped");
      }
    }
    
  private:
    virtual void onInit();
    
    bool running_;
    boost::shared_ptr<MjpegCamera> cam_;
    boost::thread thread_;
};



void
MjpegCameraNodelet::
onInit()
{
  cam_.reset (new MjpegCamera());
  thread_ = boost::thread (boost::bind (&MjpegCamera::run, cam_.get()));
  running_ = true;
}



// Register this plugin with pluginlib.  Names must match nodelet_velodyne.xml.
// parameters are: package, class name, class type, base class type
PLUGINLIB_DECLARE_CLASS (mjpeg_camera, driver,
                         MjpegCameraNodelet, nodelet::Nodelet);
