#ifndef _SOCROB_DISPLAY_H_
#define _SOCROB_DISPLAY_H_

#include <string>

#include <ros/node_handle.h>
#include <image_transport/image_transport.h>
#include <sensor_msgs/image_encodings.h>



namespace cv
{
  class Mat;
}



namespace socrob
{
  class Display
  {
    public:
      Display (std::string const& topic);
      ~Display () {}
      
      bool active() const;
      
      void set (cv::Mat const& image,
                std::string const& enconding = sensor_msgs::image_encodings::BGR8);
                
    private:
      ros::NodeHandle nh_;
      image_transport::ImageTransport it_;
      image_transport::Publisher pub_;
  };
}

#endif
