#include <socrob/display.h>

#include <ros/time.h>
#include <cv_bridge/cv_bridge.h>
#include <opencv2/core/core.hpp>



using namespace std;
using namespace ros;
using namespace socrob;



Display::
Display (std::string const& topic) :
  nh_ ("~"),
  it_ (nh_),
  pub_ (it_.advertise (topic, 1))
{
}



bool
Display::
active() const
{
  return pub_.getNumSubscribers() > 0;
}



void
Display::
set (cv::Mat const& image,
     std::string const& enconding)
{
  cv_bridge::CvImage out_msg;
  out_msg.header.stamp = Time::now();
  out_msg.encoding = enconding;
  out_msg.image = image;
  pub_.publish (out_msg.toImageMsg());
}
