## FindMKL
## Mantainer: Joao Reis <joaocgreis@gmail.com>

IF (MKL_INCLUDE_DIRS AND MKL_LIBRARIES)
   # in cache already - wont print a message
   SET(MKL_FIND_QUIETLY TRUE)
ENDIF ()

########################################################################
##  general find

IF(DEFINED ENV{MKLROOT})
  SET(MKLROOT $ENV{MKLROOT})
ELSE()
  # use default
  SET(MKLROOT "/opt/intel/mklsocrob")
ENDIF()

IF(EXISTS ${MKLROOT})
  SET(MKL_INCLUDE_DIRS "${MKLROOT}/include")
  SET(MKL_LIBRARIES "-lmkl_core -lmkl_gnu_thread" )
ENDIF()

########################################################################
## finished - now just set up flags

INCLUDE(FindPackageHandleStandardArgs)

FIND_PACKAGE_HANDLE_STANDARD_ARGS(MKL DEFAULT_MSG MKL_LIBRARIES MKL_INCLUDE_DIRS)

MARK_AS_ADVANCED(MKL_INCLUDE_DIRS MKL_LIBRARIES)
