#!/usr/bin/env python
import roslib; roslib.load_manifest('socrob_ros')
import rospy
from socrob_ros.msg import ControlInput
from std_srvs.srv import Empty


def compass_calibration():
    pub = rospy.Publisher('control_input_final', ControlInput)
    rospy.init_node('compass_calibration')
    rospy.sleep(1.0)

    rospy.loginfo("Waiting for calibration service...")
    rospy.wait_for_service('compass/calibrate')

    rospy.loginfo("Starting motors...")
    pub.publish(ControlInput(angular=0.6283))
    rospy.sleep(1.0)

    rospy.loginfo("Calibrating compass...")
    try:
        calibrate = rospy.ServiceProxy('compass/calibrate', Empty)
        calibrate()
    except rospy.ServiceException, e:
        print "Service call failed: %s"%e

    rospy.sleep(30.0)
    rospy.loginfo("Calibration complete.")


if __name__ == '__main__':
    try:
        compass_calibration()
    except rospy.ROSInterruptException:
        pass
