/**
 * @Filename Kicker.hpp
 * @Description ...to be described...
 * @Status unknown
 * @Version $Id: Kicker.hpp 5866 2012-12-14 01:07:05Z jreis $
 * @Maintainer Joao Reis <joaocgreis@gmail.com>
 */

#ifndef _KICKER_HPP_
#define _KICKER_HPP_

#include "FtdiDevice.hpp"
#include <iostream>

#include <MessageKick.hpp>



/**
 * @Class Kicker Kicker.hpp "Kicker.hpp"
 * @Author Joao Reis
 */
class Kicker :
  public FtdiDevice,
  public Receiver<MessageKick>
{
  public:
    Kicker ();
    
    void
    kick (int strengh);
    
  private:
    void update3();
    void afterConnect();
    
    float getVoltagePrivate();
    void kickPrivate (int strengh);
    void startKickerPrivate();
    void stopKickerPrivate();
    void dischargeKickerPrivate();
    
    void updateKickerOn (bool kickerOn);
    
    bool shouldBeCharging_;
};

#endif
