#ifndef DRIVER_VIEW_H
#define DRIVER_VIEW_H

#include <string>

#include <ros/ros.h>
#include <image_transport/image_transport.h>

#include <socrob/display.h>



class DriverView
{
  public:
    DriverView ();
    
  private:
    void
    imageCallback (const sensor_msgs::ImageConstPtr& image);
    
    void
    check_active (ros::TimerEvent const&);
    
    void
    update_params ();
    
    ros::NodeHandle nh_;
    image_transport::ImageTransport it_;
    
    socrob::Display display_;
    
    image_transport::Subscriber image_sub_;
    
    ros::Timer activation_timer_;
    
    const double ROTATION_ANGLE_;
    
    double front_angular_span_;
    double front_angular_left_;
    int width_;
    int height_;
    double front_radial_bottom_;
    double front_radial_top_;
    double rear_mul_;
    double rear_angular_span_;
    double rear_angular_left_;
    int rear_width_;
    int rear_height_;
    int rear_start_col_;
    double rear_radial_bottom_;
    double rear_radial_top_;
};

#endif
