#include "transform_cache.h"

#include <socrob/math.h>
using namespace socrob;

#include <WorldDefinition.hpp>
#include <WorldInfo.hpp>
#include <Integer.hpp>
#include <Float.hpp>



using namespace std;



TransformCache::
TransformCache () :
  transf_ ()
{
  init (1056, 1056);
}



void
TransformCache::
init (int xMax,
      int yMax)
{
  xMax_ = xMax;
  yMax_ = yMax;
  
  cache_ = vector<vector<pair<double, double> > > (xMax_, vector<pair<double, double> > (yMax_, pair<double, double>()));
  
  for (int x = 0; x < xMax_; x++) {
    for (int y = 0; y < yMax_; y++) {
      pair<double, double> transition;
      transf_.fromImageFrame2RobotFrame (x, y, transition.first, transition.second);
      cache_.at (x).at (y) = transition;
    }
  }
}



pair<double, double> const&
TransformCache::
get (int x,
     int y)
{
#if 0
  /// This allows for dynamic redimensioning in case of cache size error (try if there is a SEGFAULT)
  if (x >= xMax_) {
    init (x, yMax_);
  }
  if (y >= yMax_) {
    init (xMax_, y);
  }
#endif
  return cache_[x][y];
}



cv::Point
TransformCache::
reverse (double x,
         double y)
{
  double tX, tY;
  transf_.fromRobotFrame2ImageFrame (x, y, tX, tY);
  return cv::Point (round (tX), round (tY));
}
