#ifndef TRANSFORM_CACHE_H
#define TRANSFORM_CACHE_H

#include <vector>

#include <opencv2/core/core.hpp>

#include <FisheyeImageFrameRobotFrameTransformations.hpp>



class TransformCache
{
  public:
    TransformCache();
    
    std::pair<double, double> const& get (int x, int y);
    cv::Point reverse (double x, double y);
    
  private:
    void init (int xMax, int yMax);
    
    FisheyeImageFrameRobotFrameTransformations transf_;
    
    int xMax_;
    int yMax_;
    
    std::vector<std::vector<std::pair<double, double> > > cache_;
};

#endif
