/**
 * @Filename FrameTransformations2D.cpp
 * @Description FrameTransformations2D class implementation.
 * @Status Implementing
 * @Version $Id: FrameTransformations2D.cpp 5864 2012-12-08 14:40:54Z jreis $
 * @Maintainer Hugo Costelha
 */

#include "FrameTransformations2D.hpp"

#include <socrob/math.h>
using namespace socrob;



FrameTransformations2D::FrameTransformations2D()
{
}



FrameTransformations2D::~FrameTransformations2D()
{
}



void FrameTransformations2D::polar2Rect (Distance distance, Angle angle,
    Distance* x, Distance* y)
{
  *x = cos (angle) * distance;
  *y = sin (angle) * distance;
}



void FrameTransformations2D::rect2Polar (Distance x, Distance y,
    Distance* distance, Angle* angle)
{
  *distance  = hypot (x, y);
  *angle = ( (x != 0.0 || y != 0.0) ? atan2 (y, x) : 0.0);
}
