/**
 * @Filename FrameTransformations3D.cpp
 * @Description FrameTransformations3D class implementation.
 * @Status Implementing
 * @Version $Id: FrameTransformations3D.cpp 5864 2012-12-08 14:40:54Z jreis $
 * @Maintainer Hugo Costelha
 */

#include "FrameTransformations3D.hpp"

#include <socrob/math.h>
using namespace socrob;



FrameTransformations3D::FrameTransformations3D()
{
}



FrameTransformations3D::~FrameTransformations3D()
{
}



void FrameTransformations3D::spherical2Cartesian (
  Distance distance, Angle azimuth, Angle zenith,
  Distance* x, Distance* y, Distance* z)
{
  *x = distance * sin (zenith) * cos (azimuth);
  *y = distance * sin (zenith) * sin (azimuth);
  *z = distance * cos (zenith);
}



void FrameTransformations3D::cartesian2Spherical (
  Distance x, Distance y, Distance z,
  Distance* distance, Angle* azimuth, Angle* zenith)
{
  *distance  = sqrt (x * x + y * y + z * z);
  *azimuth = ( (x != 0.0 || y != 0.0) ? atan2 (y, x) : 0.0);
  *zenith = ( (x != 0.0 || y != 0.0 || z != 0.0) ? atan2 (hypot (y, x), z) : 0.0);
}
