/**
* @Filename Float.cpp
* Float Data class implementation.
* @Status Implementing
* @Version $Id: Float.cpp 5661 2012-05-11 13:43:55Z jreis $
* @Maintainer Joao Francisco (jrfe@mega.ist.utl.pt)
*/
#include "Float.hpp"

#include <sstream>



Float::Float (void) : Data(),
  value_ (0.0)
{
}



Float::Float (string stringdata) : Data(),
  value_ (strtof (stringdata.c_str(), 0))
{
}



Float::~Float (void)
{
}



Float::Float (float value) : Data(),
  value_ (value)
{
}



float Float::floatValue() const
{
  return value_;
}



void Float::setValue (float value)
{
  value_ = value;
}



shared_ptr<Parameter> Float::clone() const
{
  shared_ptr<Float> tmp (new Float (*this));
  return tmp;
}



string Float::toString() const
{
  stringstream ret;
  ret << value_;
  return ret.str();
}
