/**
* @Filename Integer.cpp
* Integer Data class implementation.
* @Status Implementing
* @Version $Id: Integer.cpp 5661 2012-05-11 13:43:55Z jreis $
* @Maintainer Joao Francisco (jrfe@mega.ist.utl.pt)
*/
#include "Integer.hpp"

#include <sstream>



Integer::Integer (void) : Data(),
  value_ (0)
{
}



Integer::~Integer (void)
{
}



Integer::Integer (int value) : Data(),
  value_ (value)
{
}



Integer::Integer (string dataString) : Data(),
  value_ (0)
{
  stringstream data;
  data << dataString;
  data >> value_;
}



int Integer::intValue() const
{
  return value_;
}



void Integer::setValue (int value)
{
  value_ = value;
}



shared_ptr<Parameter> Integer::clone() const
{
  shared_ptr<Integer> newInteger (new Integer (*this));
  return newInteger;
}



string Integer::toString() const
{
  stringstream ret;
  ret << value_;
  return ret.str();
}
