/**
* @Filename Integer.hpp
* Integer Data class header.
* @Status Implementing
* @Version $Id: Integer.hpp 5748 2012-07-04 17:44:30Z jreis $
* @Maintainer Joao Francisco (jrfe@mega.ist.utl.pt)
*/

#ifndef _INTEGER_HPP_
#define _INTEGER_HPP_
#include "Data.hpp"



/**
* @Class Integer Integer.hpp "Integer.hpp"
* Class Integer Data which represents all data that will be storable under the format Integer.
* @Author Joao Francisco
*/
class Integer : public Data
{
  public:
    /**
     * Constructor.
     * This method creates a new Integer.
     */
    Integer (void);
    
    /**
     * Constructor.
     * This method creates a new Integer.
     * @Argument value - to be store by this Integer.
     */
    Integer (int value);
    
    /**
     * Constructor.
     * This method creates a new Integer.
     * @Argument dataString - ?
     */
    Integer (string dataString);
    Integer (char const* dataString) {
      (*this) = Integer (string (dataString));
    }
    
    /**
     * This method retrieves the value held by this Integer.
     * @Returns value held by this Data, 0 if uninitialized.
     */
    int intValue() const;
    
    /**
     * ?
     * @Argument value - ?
     */
    void setValue (int value);
    
    /**
     * Destructor.
     * This method makes deinitializations for objects of this class.
     */
    ~Integer (void);
    
    /**
     * This method create a new object that is a clone of this
     * @Returns clone Parameter
     */
    shared_ptr<Parameter> clone() const;
    
    /**
     * cast operations
     * @return Integer::value
     * @Author Nelson Ramos
     */
    string toString() const;
    
  private:
    int value_;
};
#endif
