/**
* @Filename String.cpp
* String Data class implementation.
* @Status Implementing
* @Version $Id: String.cpp 5661 2012-05-11 13:43:55Z jreis $
* @Maintainer Joao Francisco (jrfe@mega.ist.utl.pt)
*/
#include "String.hpp"
#include "Parameter.hpp"



String::String() : Data(), value_()
{
}



String::~String()
{
}



String::String (std::string value) : Data(), value_ (value)
{
}



std::string String::stringValue() const
{
  return value_;
}



void String::setValue (std::string value)
{
  value_ = value;
}



shared_ptr<Parameter> String::clone() const
{
  shared_ptr<String> newString (new String (*this));
  return newString;
}



string String::toString() const
{
  return stringValue();
}




//static methods
