/**
 * @Filename HelperMessages.hpp
 * @Description Implementation of the HelperMessages class
 * @Status In progress
 * @Version $Id: HelperMessages.hpp 6061 2013-05-22 22:34:46Z jreis $
 * @Maintainer Joao Reis
 */

#ifndef COMPONENTS_HELPER_MESSAGES_HPP
#define COMPONENTS_HELPER_MESSAGES_HPP

#include <ControlInput.hpp>
#include <socrob_ros/ControlInput.h>

#include <SocRobService.hpp>



/**
 * @Class HelperMessages HelperMessages.hpp "HelperMessages.hpp"
 * Helper Messages.
 * @Author Joao Reis
 */
namespace HelperMessages
{
  inline
  void
  setRobotControls (const ControlInput& u)
  {
    static ros::Publisher pub = SocRobService::nh().advertise<socrob_ros::ControlInput> ("control_input_navigation", 1, true);
    socrob_ros::ControlInput msg;
    u.rosMsg (msg);
    pub.publish (msg);
  }
};

#endif
