/**
 * @Filename MessagePrimitiveStart.hpp
 * @Description Implementation of the MessagePrimitiveStart class
 * @Status In progress
 * @Version $Id: MessagePrimitiveStart.hpp 5866 2012-12-14 01:07:05Z jreis $
 * @Maintainer Joao Reis
 */

#ifndef COMPONENTS_MESSAGE_PRIMITIVE_START_HPP
#define COMPONENTS_MESSAGE_PRIMITIVE_START_HPP

#include <Receiver.hpp>

#include <SocRobService.hpp>



/**
 * @Class MessagePrimitiveStart MessagePrimitiveStart.hpp "MessagePrimitiveStart.hpp"
 * Message.
 * @Author Joao Reis
 */
class MessagePrimitiveStart
{
  public:
    static
    shared_ptr<MessagePrimitiveStart>
    buildAndSend (string const& recipientName) {
      cout << "MessagePrimitiveStart::buildAndSend()" << endl;
      return shared_ptr<MessagePrimitiveStart>();
    }
};



template <>
class Receiver<MessagePrimitiveStart>
{
  public:
    virtual
    ~Receiver() {}
    
    virtual
    void
    start () = 0;
};

#endif
