/**
 * @Filename MessagePrimitiveStop.hpp
 * @Description Implementation of the MessagePrimitiveStop class
 * @Status In progress
 * @Version $Id: MessagePrimitiveStop.hpp 5866 2012-12-14 01:07:05Z jreis $
 * @Maintainer Joao Reis
 */

#ifndef COMPONENTS_MESSAGE_PRIMITIVE_STOP_HPP
#define COMPONENTS_MESSAGE_PRIMITIVE_STOP_HPP

#include <Receiver.hpp>

#include <SocRobService.hpp>



/**
 * @Class MessagePrimitiveStop MessagePrimitiveStop.hpp "MessagePrimitiveStop.hpp"
 * Message.
 * @Author Joao Reis
 */
class MessagePrimitiveStop
{
  public:
    static
    shared_ptr<MessagePrimitiveStop>
    buildAndSend (string const& recipientName) {
      cout << "MessagePrimitiveStop::buildAndSend()" << endl;
      return shared_ptr<MessagePrimitiveStop>();
    }
};



template <>
class Receiver<MessagePrimitiveStop>
{
  public:
    virtual
    ~Receiver() {}
    
    virtual
    void
    stop () = 0;
};

#endif
