/**
 * @Filename MessagePrimitiveTest.hpp
 * @Description Implementation of the MessagePrimitiveTest class
 * @Status In progress
 * @Version $Id: MessagePrimitiveTest.hpp 5866 2012-12-14 01:07:05Z jreis $
 * @Maintainer Joao Reis
 */

#ifndef COMPONENTS_MESSAGE_PRIMITIVE_TEST_HPP
#define COMPONENTS_MESSAGE_PRIMITIVE_TEST_HPP

#include <Receiver.hpp>

#include <SocRobService.hpp>



/**
 * @Class MessagePrimitiveTest MessagePrimitiveTest.hpp "MessagePrimitiveTest.hpp"
 * Message.
 * @Author Joao Reis
 */
class MessagePrimitiveTest
{
  public:
    static
    shared_ptr<MessagePrimitiveTest>
    buildAndSend (string const& recipientName) {
      cout << "MessagePrimitiveTest::buildAndSend()" << endl;
      return shared_ptr<MessagePrimitiveTest>();
    }
};



template <>
class Receiver<MessagePrimitiveTest>
{
  public:
    virtual
    ~Receiver() {}
    
    virtual
    void
    test () = 0;
};

#endif
