/**
 * @Filename MessageSetRobotAcceleration.hpp
 * @Description Implementation of the MessageSetRobotAcceleration class
 * @Status In progress
 * @Version $Id: MessageSetRobotAcceleration.hpp 6061 2013-05-22 22:34:46Z jreis $
 * @Maintainer Joao Reis
 */

#ifndef COMPONENTS_MESSAGE_SET_ROBOT_ACCELERATION_HPP
#define COMPONENTS_MESSAGE_SET_ROBOT_ACCELERATION_HPP

#include <Receiver.hpp>

#include <SocRobService.hpp>
#include <ControlInput.hpp>
#include <HelperMessages.hpp>

#include <socrob_ros/ControlInput.h>



/**
 * @Class MessageSetRobotAcceleration MessageSetRobotAcceleration.hpp "MessageSetRobotAcceleration.hpp"
 * Message.
 * @Author Joao Reis
 */
class MessageSetRobotAcceleration
{
  public:
    static
    shared_ptr<MessageSetRobotAcceleration>
    buildAndSend (float ax,
                  float ay,
                  float alpha,
                  CONTROL_PRIORITY vPrio) {
      ControlInput u;
      u.setType (ACCELERATION);
      u.setLinearX (ax);
      u.setLinearY (ay);
      u.setAngular (alpha);
      u.setPriority (vPrio);
      
      HelperMessages::setRobotControls (u);
      
      return shared_ptr<MessageSetRobotAcceleration>();
    }
};

#endif
