/**
 * @Filename MessageSetRobotFinalAcceleration.hpp
 * @Description Implementation of the MessageSetRobotFinalAcceleration class
 * @Status In progress
 * @Version $Id: MessageSetRobotFinalAcceleration.hpp 5866 2012-12-14 01:07:05Z jreis $
 * @Maintainer Joao Reis
 */

#ifndef COMPONENTS_MESSAGE_SET_ROBOT_FINAL_ACCELERATION_HPP
#define COMPONENTS_MESSAGE_SET_ROBOT_FINAL_ACCELERATION_HPP

#include <Receiver.hpp>

#include <SocRobService.hpp>
#include <ControlInput.hpp>
#include <HelperMessages.hpp>

#include <socrob_ros/ControlInput.h>



/**
 * @Class MessageSetRobotFinalAcceleration MessageSetRobotFinalAcceleration.hpp "MessageSetRobotFinalAcceleration.hpp"
 * Message.
 * @Author Joao Reis
 */
class MessageSetRobotFinalAcceleration
{
  public:
    static
    shared_ptr<MessageSetRobotFinalAcceleration>
    buildAndSend (float ax,
                  float ay,
                  float alpha,
                  CONTROL_PRIORITY vPrio) {
      ControlInput u;
      u.setType (ACCELERATION);
      u.setLinearX (ax);
      u.setLinearY (ay);
      u.setAngular (alpha);
      u.setPriority (vPrio);
      
      static ros::Publisher pub = SocRobService::nh().advertise<socrob_ros::ControlInput> ("control_input_final", 1, true);
      socrob_ros::ControlInput msg;
      u.rosMsg (msg);
      pub.publish (msg);
      
      return shared_ptr<MessageSetRobotFinalAcceleration>();
    }
};



template <>
class Receiver<MessageSetRobotFinalAcceleration>
{
  public:
    Receiver () {}
    
    virtual
    ~Receiver() {}
};

#endif
