/**
 * @Filename MessageSetRobotVelocity.hpp
 * @Description Implementation of the MessageSetRobotVelocity class
 * @Status In progress
 * @Version $Id: MessageSetRobotVelocity.hpp 6061 2013-05-22 22:34:46Z jreis $
 * @Maintainer Joao Reis
 */

#ifndef COMPONENTS_MESSAGE_SET_ROBOT_VELOCITY_HPP
#define COMPONENTS_MESSAGE_SET_ROBOT_VELOCITY_HPP

#include <Receiver.hpp>

#include <SocRobService.hpp>
#include <ControlInput.hpp>
#include <HelperMessages.hpp>

#include <socrob_ros/ControlInput.h>



/**
 * @Class MessageSetRobotVelocity MessageSetRobotVelocity.hpp "MessageSetRobotVelocity.hpp"
 * Message.
 * @Author Joao Reis
 */
class MessageSetRobotVelocity
{
  public:
    static
    shared_ptr<MessageSetRobotVelocity>
    buildAndSend (float vx,
                  float vy,
                  float w,
                  CONTROL_PRIORITY vPrio = BALANCED) {
      ControlInput u;
      u.setType (VELOCITY);
      u.setLinearX (vx);
      u.setLinearY (vy);
      u.setAngular (w);
      u.setPriority (vPrio);
      
      HelperMessages::setRobotControls (u);
      
      return shared_ptr<MessageSetRobotVelocity>();
    }
};

#endif
