/**
 * @Filename MessageSignalLocalBallUnseen.hpp
 * @Description Implementation of the MessageSignalLocalBallUnseen class
 * @Status In progress
 * @Version $Id: MessageSignalLocalBallUnseen.hpp 5866 2012-12-14 01:07:05Z jreis $
 * @Maintainer Joao Reis
 */

#ifndef COMPONENTS_MESSAGE_SIGNAL_LOCAL_BALL_UNSEEN_HPP
#define COMPONENTS_MESSAGE_SIGNAL_LOCAL_BALL_UNSEEN_HPP

#include <Receiver.hpp>

#include <SocRobService.hpp>

#include <std_msgs/Header.h>



/**
 * @Class MessageSignalLocalBallUnseen MessageSignalDoneImageBall.hpp "MessageSignalDoneImageBall.hpp"
 * Message.
 * @Author Joao Reis
 */
class MessageSignalLocalBallUnseen
{
  public:
    static
    shared_ptr<MessageSignalLocalBallUnseen>
    buildAndSend () {
      static ros::NodeHandle n;
      static ros::Publisher pub = n.advertise<std_msgs::Header> ("ball_unseen", 1);
      
      std_msgs::Header noball;
      
      pub.publish (noball);
      
      return shared_ptr<MessageSignalLocalBallUnseen>();
    }
};



template <>
class Receiver<MessageSignalLocalBallUnseen>
{
  public:
    Receiver () :
      nh(),
      sub (nh.subscribe ("ball_unseen", 1, &Receiver<MessageSignalLocalBallUnseen>::ballCallback, this))
    {}
    
    virtual
    ~Receiver() {}
    
    void
    ballCallback (const std_msgs::Header::ConstPtr&) {
      signalLocalBallUnseen ();
    }
    
    virtual
    void
    signalLocalBallUnseen () = 0;
    
  private:
    ros::NodeHandle nh;
    ros::Subscriber sub;
};

#endif
