/**
 * @Filename MessageWorldInfoNewData.hpp
 * @Description Implementation of the MessageWorldInfoNewData class
 * @Status In progress
 * @Version $Id: MessageWorldInfoNewData.hpp 5866 2012-12-14 01:07:05Z jreis $
 * @Maintainer Joao Reis
 */

#ifndef COMPONENTS_MESSAGE_WORLD_INFO_NEW_DATA_HPP
#define COMPONENTS_MESSAGE_WORLD_INFO_NEW_DATA_HPP

#include <Receiver.hpp>

#include <SocRobService.hpp>
#include <Data.hpp>



/**
 * @Class MessageWorldInfoNewData MessageWorldInfoNewData.hpp "MessageWorldInfoNewData.hpp"
 * Message.
 * @Author Joao Reis
 */
class MessageWorldInfoNewData
{
  public:
    static
    shared_ptr<MessageWorldInfoNewData>
    buildAndSend (string const& recipientName,
                  string const& dataName,
                  shared_ptr<Data const> const& data) {
      cout << "MessageWorldInfoNewData::buildAndSend()" << endl;
      return shared_ptr<MessageWorldInfoNewData>();
    }
};



template <>
class Receiver<MessageWorldInfoNewData>
{
  public:
    virtual
    ~Receiver() {}
    
    virtual
    void
    newData (string const& dataName,
             shared_ptr<Data const> const& data) = 0;
};

#endif
