/**
 * @Filename MessageWorldInfoUpdateData.hpp
 * @Description Implementation of the MessageWorldInfoUpdateData class
 * @Status In progress
 * @Version $Id: MessageWorldInfoUpdateData.hpp 5866 2012-12-14 01:07:05Z jreis $
 * @Maintainer Joao Reis
 */

#ifndef COMPONENTS_MESSAGE_WORLD_INFO_UPDATE_DATA_HPP
#define COMPONENTS_MESSAGE_WORLD_INFO_UPDATE_DATA_HPP

#include <Receiver.hpp>

#include <SocRobService.hpp>
#include <Data.hpp>



/**
 * @Class MessageWorldInfoUpdateData MessageWorldInfoUpdateData.hpp "MessageWorldInfoUpdateData.hpp"
 * Message.
 * @Author Joao Reis
 */
class MessageWorldInfoUpdateData
{
  public:
    static
    shared_ptr<MessageWorldInfoUpdateData>
    buildAndSend (string const& recipientName,
                  string const& dataName,
                  shared_ptr<Data const> const& data) {
      cout << "MessageWorldInfoUpdateData::buildAndSend()" << endl;
      return shared_ptr<MessageWorldInfoUpdateData>();
    }
};



template <>
class Receiver<MessageWorldInfoUpdateData>
{
  public:
    virtual
    ~Receiver() {}
    
    virtual
    void
    updateData (string const& dataName,
                shared_ptr<Data const> const& data) = 0;
};

#endif
