/**
 * @Filename Parameter.cpp
 * @Description Parameter implementation
 * @Status Work in Progress
 * @Version $Id: Parameter.cpp
 * @Maintainer nmsra (nmsra@mega.ist.utl.pt)
 */

#include <pthread.h>

#include "Parameter.hpp"
#include "String.hpp"
#include <errno.h>
#include <string.h>



Parameter::Parameter() :
  clonable_ (true)
{
}



Parameter::~Parameter()
{
}



void Parameter::setClonable (bool value)
{
  clonable_ = value;
}



Parameter::Parameter (const Parameter& oldParameter) :
  clonable_ (oldParameter.clonable_)
{
  if (!oldParameter.clonable_)
    std::cerr << "Parameter: trying to clone an unclonable parameter!"
              << std::endl;
}



Parameter& Parameter::operator= (const Parameter& oldParameter)
{
  if (!oldParameter.clonable_)
    std::cerr << "Parameter: trying to copy an unclonable parameter!"
              << std::endl;
              
  clonable_ = oldParameter.clonable_;
  return *this;
}
