/**
 * @Filename SocRobService.cpp
 * @Description Helper
 * @Status Work in Progress
 * @Version $Id: SocRobService.cpp 5866 2012-12-14 01:07:05Z jreis $
 * @Maintainer Joao Reis (joaocgreis@gmail.com)
 */

#include "SocRobService.hpp"

#include <WorldInfo.hpp>



void
SocRobService::
setServiceDefaultActive (bool value,
                         float maxRatePerSec)
{
  if (value) {
    if (0 == maxRatePerSec) {
      maxRatePerSec = 100;
    }
    
    update_timer.stop();
    update_timer = nh().createTimer (ros::Duration (1.0 / maxRatePerSec), &SocRobService::rosupdate, this);
  }
  else {
    update_timer.stop();
  }
}



void
SocRobService::
rosrun()
{
  initialize();
  ros::spin();
  update_timer.stop();
}



ros::NodeHandle&
SocRobService::
nh()
{
  static ros::NodeHandle n;
  return n;
}



void
SocRobService::
putDataWI (string slotName,
           shared_ptr<Data const> data)
{
  WorldInfo::putData (slotName, data);
}



shared_ptr<Data const>
SocRobService::
getDataWI (string slotName)
{
  return WorldInfo::getData (slotName);
}
