/**
 * @Filename SocRobService.hpp
 * @Description Helper
 * @Status Work in Progress
 * @Version $Id: SocRobService.hpp 5866 2012-12-14 01:07:05Z jreis $
 * @Maintainer Joao Reis (joaocgreis@gmail.com)
 */

#ifndef SOCROB_SERVICE_H
#define SOCROB_SERVICE_H

#include <socrob/socrob.h>

#include <ros/ros.h>

#include <Data.hpp>
#include <Logger.hpp>
using namespace mermaid::support::logging::LogAux;



class SocRobService
{
  public:
    virtual bool initialize() {
      return true;
    }
    virtual bool finalize() {
      return true;
    }
    
    virtual void update() {};
    void rosupdate (const ros::TimerEvent&) {
      update();
    }
    
    void setServiceDefaultActive (bool value, float maxRatePerSec);
    
    void rosrun();
    
    static ros::NodeHandle& nh();
    
    void putDataWI (string slotName, shared_ptr<Data const> data);
    shared_ptr<Data const> getDataWI (string slotName);
    
  private:
    ros::Timer update_timer;
};

#endif
