#ifndef CAMERA_WATCHDOG_H
#define CAMERA_WATCHDOG_H

#include <ros/ros.h>
#include <image_transport/image_transport.h>



class CameraWatchdog
{
  public:
    CameraWatchdog ();
    
  private:
    void
    updateParams();
    
    void
    imageCallback (const sensor_msgs::ImageConstPtr& image);
    
    void
    timer (ros::TimerEvent const& timer_event);
    
    void
    updateOk (bool ok);
    
    double max_period_;
    
    ros::Time last_time_;
    
    bool ok_;
    
    ros::NodeHandle nh_;
    image_transport::ImageTransport it_;
    ros::Publisher ok_pub_;
    image_transport::Subscriber image_sub_;
    ros::Timer timer_;
};

#endif
