#ifndef SHOW_STOPPER_H
#define SHOW_STOPPER_H

#include <ros/ros.h>
#include <std_msgs/Bool.h>



class ShowStopper
{
  public:
    ShowStopper ();
    
  private:
    void
    updateParams();
    
    void
    cameraCallback (std_msgs::Bool const& ok);
    
    void
    temperatureCallback (std_msgs::Bool const& ok);
    
    void
    timer (ros::TimerEvent const&);
    
    void
    updateOk ();
    
    bool ignore_camera_;
    bool ignore_temperature_;
    
    bool camera_ok_;
    bool temperature_ok_;
    
    bool all_ok_;
    
    ros::NodeHandle nh_;
    ros::Publisher all_ok_pub_;
    ros::Subscriber camera_sub_;
    ros::Subscriber temperature_sub_;
    ros::Timer timer_;
};

#endif
