#ifndef TEMPERATURE_WATCHDOG_H
#define TEMPERATURE_WATCHDOG_H

#include <ros/ros.h>

#include <socrob_ros/TemperatureStamped.h>



class TemperatureWatchdog
{
  public:
    TemperatureWatchdog ();
    
  private:
    void
    updateParams();
    
    void
    temperatureCallback (const socrob_ros::TemperatureStamped::ConstPtr& msg);
    
    void
    updateOk (bool ok);
    
    int stop_temp_;
    int move_again_temp_;
    
    bool ok_;
    
    ros::NodeHandle nh_;
    ros::Publisher ok_pub_;
    ros::Subscriber temp_sub_;
};

#endif
